-- Author      : admin
-- Create Date : 10/13/2019 2:25:25 PM

do
    local a = newArray();
    local b = newArray();

    local c = a.concat(b);

    assert(0 == #c, 'c should not contain any items');
    assert(a ~= c, 'c should not be a');
    assert(b ~= c, 'c should not be b');
end

do
    local a = newArray(2);
    local b = newArray(1);

    local c = a.concat(b);

    assert(2 == #c, 'c should contain two items');
    assert(c[1] == 2, 'first index should be 2')
    assert(c[2] == 1, 'second index should be 1')
end

do
    local a = newArray();
    local b = 1;
    local c = 'two';
    local d = {3, 4, 5, 6};
    local e = false;

    local f = a.concat(b, c, d, e);

    assert(7 == #f, 'c should contain seven items');
    assert(f[1] == 1, 'first index should be 2')
    assert(f[2] == 'two', 'second index should be two')
    assert(f[3] == 3, 'second index should be 3')
    assert(f[4] == 4, 'second index should be 4')
    assert(f[5] == 5, 'second index should be 5')
    assert(f[6] == 6, 'second index should be 6')
    assert(f[7] == false, 'second index should be false')
end

