-- Author      : admin
-- Create Date : 10/13/2019 2:28:08 PM

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);
    
    local b = a.findIndex();

    assert(b == -1, 'expect b to be nil');
end

do
    local a = newArray('1', '2', '3', '4', '5', '6', '7', '8', '9');
    
    local b = a.findIndex(function(v, i, arr)
        assert(type(v) == 'string');
        assert(type(i) == 'number');
        assert(type(arr) == 'table');
        assert(arr == a);

        -- return implicity false
    end);

    assert(b == -1, 'expect b to be nil');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);
    
    local b = a.findIndex(function(v)
        return v == 1;
    end, 2);

    assert(b == -1, 'expect b to be 10');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);
    
    local b = a.findIndex(function(v)
        return v == 5;
    end);

    assert(b == 5, 'expect b to be 5');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9, 5);
    
    local b = a.findIndex(function(v)
        return v == 5;
    end, 6);

    assert(b == 10, 'expect b to be 10');
end